#include <stdio.h>
#include <stdlib.h>
typedef unsigned long card;

int div2_3(card n,int *d2,int *d3)
{*d2=0;
 *d3=0;
 while (!(n&1)) {(*d2)++;
		 n>>=1;
		}
 while (!(n%3)) {(*d3)++;
                 n/=3;
                }
 return n==1;
}

long count(card n)
{int d2,d3;
 card r,d,p;
 if (!div2_3(n+1,&d2,&d3)) return 0;
 if (!(d2*d3)) return 1;
 r=1;
 d=d2+d3;
 for (p=1;p<=d2;p++) r=r*d--/p;
 for (p=1;p<=d3;p++) r=r*d--/p;
 return r;
}

int main(int argc, char *argv[])
{FILE *fin, *fcomp;
 long in,comp;
 char buf[32], *e;
 if (argc!=4)
 {printf("Argument error\n");
  return 0;
 }
 if (!(fin = fopen(argv[1], "r")))      // input file
 {printf("Cannot open input.\n");
  return 0;
 }
 buf[0]=0;
 fscanf(fin,"%30s",buf);
 in=strtol(buf, &e, 10);
 if (!*buf||*e)
 {printf("Wrong input.\n");
  fclose(fin);
  return 0;
 }
 if (!(fcomp = fopen(argv[2], "r")))    // competitor file
 {printf("0\nCannot open result.\n");
  fclose(fin);
  return 0;
 }
 buf[0]=0;
 fscanf(fcomp,"%30s",buf);
 comp=strtol(buf, &e, 10);
 if (!*buf||*e)
 {printf("0\nWrong output format.\n");
  fclose(fin);
  fclose(fcomp);
  return 0;
 }
 if (count(in)==comp)  printf("10\nCorrect solution.\n");
 else printf("0\nIncorrect result.\nThe output for %ld should be %ld, and not %ld.\n",in,count(in),comp);
 fclose(fin);
 fclose(fcomp);
 return 0;
}